// Программа сложение колебаний
// СУНЦ НГУ 2002-2016
// Program beats
////////////////////////////////////////////////////////////
#include <cmath>

#include <mpp/mpp_window.h>  
#include <mpp/draw.h>

using namespace mpp;

Scale scale(0, 50, -2.5, 2.5);
Roll roll(FL_GREEN, scale);

double omega1=1, omega2=1.2;
double a1=1.0, a2=1.0;
double dt=0.15;
double t=0.0;                // текущее время

void ff(){
    double y;
     //  Основной цикл
     while (may_i_repeat()){          // пока не попросят редактирования
          t+=dt;
          y=a1*cos(omega1*t)+a2*cos(omega2*t);
          roll.add(t, y);
          msleep(2e-3);               // задержка выполнения программы в секундах
          ask_update();               // перерисовать окошко
     }
};

int main(void){   
     Mpp_window win;    // Основное окно
     // Построение таблицы-пульта
     win.table.add_item("Time = ", t);
     win.table.add_item("a1 = ", a1);
     win.table.add_item("a2 = ", a2);
     win.table.add_item("omega1 = ", omega1);
     win.table.add_item("omega2 = ", omega2);
     win.table.add_item("dt = ", dt);

     // Что будем рисовать
     win.canvas.add_shape(roll);

     set_work(ff);  //  Подключаем расчетную функцию
     start();
     return run();
}
