// Программа диффузия
// СУНЦ НГУ 2002-2004-2020
// Program diffus
////////////////////////////////////////////////////////////
#include <cmath>

#include <mpp/mpp_window.h>
#include <mpp/draw.h>

#include <stdlib.h>

const int sz=10000;
double x[sz];
double y[sz];
double t=0;

using namespace mpp;

Scale scale(-15.0, 15.0, 0.0, sz, NO_KEEP_RATIO);   // Масштаб

void ff() {
    srand48((long)time(0));           // инициализация генератора случайных чисел
    while (may_i_repeat()) {          // пока не попросят редактирования
        t+=1.0;                       // текущий шар по времени время
        for (int i=0; i<sz; i++) {
            x[i]+=(drand48()*2)-1;
        }
        msleep(3e-2);
        ask_update();                 // перерисовать окошко, обновить пульт
    }
};

int main(void) {
    Mpp_window win;				     // отображаемое окно
    for (int i=0; i<sz; i++) {       // начальные положения частиц
        y[i]=i;                      
        x[i]=0.0;
    }

//  Построение таблицы-пульта
    win.table.add_item("Time = ", t);

//  Что будем рисовать
    win.canvas.add_shape(new Plot_a(x, y, sz, FL_GREEN, scale));

    set_work(ff);  //  Подключаем расчетную функцию
    start();
    return run();
}
