// Программа планеты
// СУНЦ НГУ 2002-2016
// Program planets
////////////////////////////////////////////////////////////
#include <cmath>

#include <mpp/mpp_window.h>
#include <mpp/draw.h>
                
using namespace mpp;

double alpha=1.0;
double x,  y;       // координаты планеты
double vx, vy;      // компоненты скорости
double ax, ay;      // компоненты ускорения
double R;           // расстояние до центра
double a;           // модуль ускорения
double dt=0.01;     // шаг по времени

Scale scale(-3, 3, -3, 3, KEEP_RATIO);                 // Масштаб
Orbit orbit(10000, 100, FL_WHITE, FL_GREEN, scale);    // Отрисовка траектории
  
void ff(){
//  Основной цикл расчетов
   while (may_i_repeat()){           // Пока не попросят остановить расчет
      x+=vx*dt;  y+=vy*dt;
      R=sqrt(x*x+y*y);
      a=alpha/(R*R);
      ax=(-x)/R*a; ay=(-y)/R*a;
      vx+=ax*dt; vy+=ay*dt;      
      orbit.add(x, y);               // добавить точку к траектории
      ask_update();                  // перерисовать окошко
      msleep(1e-3);                  // задержка в секундах 
   }
   x=2.5;  y=0.0;     // Начальные условия - для подбора первой космической скорости
   vx=0.0; vy=0.25;
   ask_update();
};

int main(void){
   Mpp_window win;            // Создаем окно

   x=2.5;  y=0.0;             // Начальные условия
   vx=0.0; vy=0.25;
   //  Построение таблицы-пульта
   win.table.add_item("dt = ", dt);
   win.table.add_item("X = ", x);
   win.table.add_item("Y = ", y);
   win.table.add_item("VX = ", vx);
   win.table.add_item("VY = ", vy);
  
   // Что будем рисовать
   win.canvas.add_shape(new Circle(0,0,0.1, FL_YELLOW, scale));   // рисуем Солнце :)
   win.canvas.add_shape(orbit);
   win.canvas.scale(scale, "x = ", "y = "); // измерение координат

   set_work(ff);  // Подключаем расчетную функцию
   start();
   return run();    
}
